import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:panda/cubit/panda.cubit.dart';
import 'package:panda/models/view-config.model.dart';
import 'package:panda/widgets/form-view.widget.dart';

// Single Section Layout expects that none of the top level view configs are of type group.
class PandaSingleSectionLayout extends StatefulWidget {
  const PandaSingleSectionLayout({Key? key}) : super(key: key);

  @override
  _PandaSingleSectionLayoutState createState() => _PandaSingleSectionLayoutState();
}

class _PandaSingleSectionLayoutState extends State<PandaSingleSectionLayout> {
  PandaCubit get _bloc => PandaCubit.of(context);
  List<PandaViewConfigModel>? viewConfigs;

  @override
  void initState() {
    super.initState();
    viewConfigs = _bloc.state.formDescriptor!.viewConfigs;
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: const EdgeInsets.symmetric(vertical: 12.0),
      child: SingleChildScrollView(
        padding: const EdgeInsets.symmetric(horizontal: 24.0),
        child: Column(
          children: [
            ...(viewConfigs ?? []).map((PandaViewConfigModel viewConfig) {
              return BlocProvider.value(
                value: _bloc,
                child: PandaFormViewWidget(
                  [
                    viewConfig.keyName,
                  ],
                ),
              );
            }).toList(),
          ],
        ),
      ),
    );
  }
}
