import 'dart:collection';

import 'package:panda/models/view-config-types/checkbox-type-config.model.dart';
import 'package:panda/models/view-config-types/view-config.type.dart';
import 'package:panda/models/view-config.model.dart';

class PandaAppendableConfigModel {
  dynamic expectedParentValue;
  PandaViewConfigModel? viewConfig;

  PandaAppendableConfigModel({this.expectedParentValue, this.viewConfig});

  PandaAppendableConfigModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) return;

    expectedParentValue = json["expectedParentValue"];
    if (json["viewConfig"] != null) {
      viewConfig = PandaViewConfigModel.fromJson(json["viewConfig"]);
    }
  }

  Map<String, dynamic> toJson() {
    return {
      "expectedParentValue": expectedParentValue,
      "viewConfig": viewConfig?.toJson(),
    };
  }

  bool shouldDisplay(PandaViewConfigModel parentViewConfig, LinkedHashMap<String, dynamic>? node) {
    if (expectedParentValue == null) {
      return true;
    }

    final value = (node ?? const {})["value"];
    if (value == null) {
      return false;
    }

    if (parentViewConfig.type == PandaViewConfigType.Checkbox) {
      final typeConfig = parentViewConfig.typeConfig as PandaCheckboxTypeConfigModel;
      if (typeConfig.multi!) {
        return (value as List).contains(expectedParentValue);
      }
    }

    return value == expectedParentValue;
  }
}
