import 'dart:collection';

import 'package:panda/models/view-config-types/view-config.type.dart';
import 'package:panda/models/view-config.model.dart';

class PandaFormDescriptorModel {
  String? id;
  String? title;
  String? versionName;

  // DisplayConfig displayConfig;
  List<PandaViewConfigModel>? viewConfigs;

  PandaFormDescriptorModel({this.id, this.title, this.versionName, this.viewConfigs});

  PandaFormDescriptorModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    id = json["_id"];
    title = json["title"];
    versionName = json["versionName"];
    viewConfigs =
        List.from(json["viewConfigs"]).map((viewConfigJson) => PandaViewConfigModel.fromJson(viewConfigJson)).toList();
  }

  static List<PandaFormDescriptorModel> fromJsonList(List<dynamic>? json) {
    return (json ?? []).map((x) => PandaFormDescriptorModel.fromJson(x)).toList();
  }

  Map<String, dynamic> toJson() {
    return {
      "_id": id,
      "title": title,
      "versionName": versionName,
      "viewConfigs": viewConfigs!.map((viewConfig) => viewConfig.toJson()).toList(),
    };
  }

  List<String?> getViewConfigKeysOfType(PandaViewConfigType type) {
    return viewConfigs!.expand((viewConfig) => viewConfig.getChildrenConfigKeysOfType(type)).toList();
  }
}
