import 'dart:collection';

import 'package:panda/models/validation-config/validator.model.dart';

class PandaValidationConfig {
  List<PandaValidatorConfig>? validators;

  PandaValidationConfig({
    this.validators,
  });

  PandaValidationConfig.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    validators = List.from(json["validators"])
        .map((validatorConfigJson) => PandaValidatorConfig.fromJson(validatorConfigJson))
        .toList();
  }

  Map<String, dynamic> toJson() {
    return {
      "validators": validators?.map((e) => e.toJson()).toList() ?? const [],
    };
  }
}
