import 'dart:collection';

import 'package:flutter/widgets.dart';
import 'package:panda/models/public.dart';

class PandaDividerTypeConfig implements PandaTypeConfigModel {
  final double? paddingLeft;
  final double? paddingTop;
  final double? paddingRight;
  final double? paddingBottom;

  EdgeInsets get padding => EdgeInsets.fromLTRB(
        paddingLeft ?? 0,
        paddingTop ?? 0,
        paddingRight ?? 0,
        paddingBottom ?? 0,
      );

  PandaDividerTypeConfig.fromJson(LinkedHashMap<String, dynamic>? json)
      : paddingLeft = (json?["paddingLeft"] as num?)?.toDouble(),
        paddingTop = (json?["paddingTop"] as num?)?.toDouble(),
        paddingRight = (json?["paddingRight"] as num?)?.toDouble(),
        paddingBottom = (json?["paddingBottom"] as num?)?.toDouble();

  @override
  Map<String, dynamic> toJson() {
    return {
      "paddingLeft": paddingLeft,
      "paddingTop": paddingTop,
      "paddingRight": paddingRight,
      "paddingBottom": paddingBottom,
    };
  }
}
