import 'dart:collection';

import 'package:panda/models/view-config-types/type-config.model.dart';
import 'package:panda/models/view-config.model.dart';

class PandaGroupTypeConfigModel implements PandaTypeConfigModel {
  late final List<PandaViewConfigModel> viewConfigs;

  PandaGroupTypeConfigModel({
    required this.viewConfigs,
  });

  PandaGroupTypeConfigModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    viewConfigs = List.from(json["viewConfigs"]).map((viewConfigJson) {
      return PandaViewConfigModel.fromJson(viewConfigJson);
    }).toList();
  }

  @override
  Map<String, dynamic> toJson() {
    return {
      "viewConfigs": viewConfigs.map((viewConfig) => viewConfig.toJson()).toList(),
    };
  }
}
