import 'dart:collection';

import 'package:panda/models/public.dart';

class PandaTableTypeConfigModel implements PandaTypeConfigModel {
  late final List<PandaTableColumnHeaderConfigModel>? colHeaders;
  late final List<String>? rowHeaders;

  PandaTableTypeConfigModel({
    this.colHeaders,
  });

  PandaTableTypeConfigModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    colHeaders = [for (final colHeader in json["colHeaders"]) PandaTableColumnHeaderConfigModel.fromJson(colHeader)];
    rowHeaders = (json["rowHeaders"] as List?)?.cast();
  }

  @override
  Map<String, dynamic> toJson() {
    return {
      if (colHeaders != null) "colHeaders": [for (final colHeader in colHeaders!) colHeader.toJson()],
      "rowHeaders": rowHeaders,
    };
  }
}

class PandaTableColumnHeaderConfigModel {
  final String? title;
  final PandaViewConfigModel? viewConfig;

  PandaTableColumnHeaderConfigModel.fromJson(LinkedHashMap<String, dynamic>? json)
      : title = json?["title"],
        viewConfig = json?["viewConfig"] != null ? PandaViewConfigModel.fromJson(json!["viewConfig"]) : null;

  Map<String, dynamic> toJson() {
    return {
      "title": title,
      "viewConfig": viewConfig?.toJson(),
    };
  }
}
