import 'package:flutter/widgets.dart';
import 'package:nice_flutter_kit/nice_flutter_kit.dart';
import 'package:panda/models/view-config-types/group-type-config.model.dart';
import 'package:panda/models/view-config.model.dart';
import 'package:panda/widgets/base-widget-state.dart';
import 'package:panda/widgets/base-widget.dart';
import 'package:panda/widgets/form-view.widget.dart';

class PandaGroupWidget extends PandaBaseWidget {
  const PandaGroupWidget(List<String> keyTree, {Key? key}) : super(keyTree, key: key);

  @override
  State<StatefulWidget> createState() => _PandaGroupWidgetState();
}

class _PandaGroupWidgetState extends PandaBaseWidgetState<PandaGroupWidget, PandaGroupTypeConfigModel> {
  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.stretch,
      children: <Widget>[
        Text(
          viewConfig?.title ?? NiceLocalizations.of(context).translate("panda.no_title"),
          style: const TextStyle(fontWeight: FontWeight.bold, fontSize: 21),
        ),
        Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: (typeConfig?.viewConfigs ?? []).map((PandaViewConfigModel viewConfig) {
            return Padding(
              padding: const EdgeInsets.only(top: 12.0),
              child: PandaFormViewWidget(
                [...widget.keyTree, viewConfig.keyName],
              ),
            );
          }).toList(),
        ),
      ],
    );
  }
}
