import 'dart:collection';

import 'package:flutter/material.dart';
import 'package:panda/widgets/base-widget-state.dart';
import 'package:nice_flutter_kit/nice_flutter_kit.dart';
import 'package:panda/widgets/base-widget.dart';

class PandaLongTextWidget extends PandaBaseWidget {
  const PandaLongTextWidget(List<String> keyTree, {Key? key}) : super(keyTree, key: key);

  @override
  State<StatefulWidget> createState() => _PandaLongTextWidgetState();
}

class _PandaLongTextWidgetState extends PandaBaseWidgetState<PandaLongTextWidget, void> {
  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.start,
      crossAxisAlignment: CrossAxisAlignment.stretch,
      children: <Widget>[
        Text(
          viewConfig?.title ?? NiceLocalizations.of(context).translate("panda.no_title"),
          style: const TextStyle(fontWeight: FontWeight.bold),
        ),
        Padding(
          padding: const EdgeInsets.only(top: 12.0),
          child: _buildTextInput(),
        ),
      ],
    );
  }

  Widget _buildTextInput() {
    return TextFormField(
      decoration: const InputDecoration(border: OutlineInputBorder()),
      initialValue: node!.value!["value"],
      maxLines: null,
      minLines: 2,
      keyboardType: TextInputType.multiline,
      onChanged: _setValue,
    );
  }

  void _setValue(String newValue) {
    LinkedHashMap<String, dynamic>? newNodeValue = node!.valueOrNull ?? LinkedHashMap.from({"value": null});

    newNodeValue["value"] = newValue;
    node!.sink.add(newNodeValue);
  }
}
