import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:nice_flutter_kit/nice_flutter_kit.dart';
import 'package:panda/models/form-validation.model.dart';
import 'package:rxdart/rxdart.dart';

class ReactiveError extends StatelessWidget {
  final BehaviorSubject<PandaFormValidation?>? errorNode;

  ReactiveError({required this.errorNode});

  @override
  Widget build(BuildContext context) {
    return StreamBuilder<PandaFormValidation?>(
      stream: errorNode,
      builder: (_, snapshot) {
        final errorText = snapshot.data?.errors?.firstOrNull?.error;

        final child;
        if (errorText != null) {
          child = Text(
            errorText,
            style: TextStyle(
              color: Theme.of(context).colorScheme.error,
            ),
          );
        } else {
          child = const SizedBox.shrink();
        }

        return AnimatedSize(
          duration: const Duration(milliseconds: 150),
          alignment: Alignment.bottomCenter,
          child: NiceAnimatedFadeIn(
            key: ValueKey(errorText == null),
            duration: const Duration(milliseconds: 300),
            child: child,
          ),
        );
      },
    );
  }
}
