import 'package:flutter/widgets.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:panda/cubit/panda.cubit.dart';
import 'package:panda/cubit/panda.state.dart';

class PandaSubmittedBuilder extends StatelessWidget {
  final Widget child;

  const PandaSubmittedBuilder({Key? key, required this.child}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<PandaCubit, PandaState>(
      buildWhen: (prev, curr) => prev.submitted != curr.submitted,
      builder: (context, state) {
        if (!state.submitted) return const SizedBox.shrink();
        return child;
      },
    );
  }
}
